//
//  SubviewController.h
//  SubviewTableViewTester
//
//  Created by Joar Wingfors on Tue Dec 02 2003.
//  Copyright (c) 2003 joar.com. All rights reserved.
//

/*****************************************************************************

SubviewController

Overview:

The SubviewController is a very simple class. It is the controller object for
the custom views used in the table. It provides the view, and answers to
actions methods from the view or the table view controller.

*****************************************************************************/

#import <AppKit/AppKit.h>

@interface SubviewController : NSObject
{

    IBOutlet NSView*		subview;
	IBOutlet NSButton*		iconView;
	IBOutlet NSTextField*	titleField;
	IBOutlet NSTextField*	infosField;
	IBOutlet NSTextField*	lengthField;
	IBOutlet NSButton*		checkButton;
	IBOutlet NSImageView*	checkImageView;
	IBOutlet NSImageView*	backgroundImageView;
	IBOutlet NSImageView*	newsAvView;

	NSURL*	URL;
	BOOL isSelected;
	BOOL isFinished;
	BOOL isNews;
	int length;
	NSString* appPath;
    
}

// Convenience factory method
+ (id) controller;

// The view displayed in the table view
- (NSView *) view;

- (BOOL)isNewsAvailable;
- (BOOL)isSelected;
- (BOOL)isFinished;
- (NSURL*)url;
- (int)length;
- (NSString*)title;
- (void)setTitle:(NSString*)title withInformations:(NSString*)infos currentVersion:(NSString*)oldVersion length:(NSString*)lengthS intelOnly:(BOOL)value systemChanges:(NSString*)systeminfo;
- (void)setAppPath:(NSString*)path;
- (void)setURL:(NSString*)url;
- (void)setLengthInteger:(int)integer;
- (void)setNewsAvailable:(BOOL)value;
- (IBAction)revealApp:(id)sender;
- (IBAction)selectApp:(id)sender;

- (void)setHighlighted:(BOOL)highlight;

- (void)deselect;
- (void)select;

- (void)beginDownload;
- (void)downloadCancelled;
- (void)downloadFinished;
- (void)runDownload;

@end
